#include <extdll.h>
#include <meta_api.h>

#include "chooker.h"

#if _MSC_VER
	#if _MSC_VER >= 1400
		#define stricmp _stricmp
	#endif
#endif

#ifdef __linux__
	#define stricmp	strcasecmp
#endif

plugin_info_t Plugin_info =
{
	META_INTERFACE_VERSION,            // ifvers
	"Bones Fix",                  // name
	"0.0.0.1",                        // version
	"10/11/2013",                  // date
	"Andrei",                     // author
	"https://forums.alliedmods.net/",            // url
	"SSB FIX",                  // logtag, all caps please
	PT_ANYTIME,                     // (when) loadable
	PT_ANYPAUSE                     // (when) unloadable
};

meta_globals_t *gpMetaGlobals;
mutil_funcs_t *gpMetaUtilFuncs;
enginefuncs_t g_engfuncs;
gamedll_funcs_t * gpGamedllFuncs;
globalvars_t  *gpGlobals;

CHooker  HookerClass;
CHooker* Hooker = &HookerClass;

#ifdef _WIN32 
	typedef void ( __cdecl *FuncStudioSetupBones )( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending,edict_t * pEdict, signed int iBone );
	typedef void ( __cdecl *FuncStudioSetupBonesEngine )( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending,edict_t * pEdict, signed int iBone );
#else
	typedef void ( *FuncStudioSetupBones )( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending, edict_t * pEdict, signed int iBone );
	typedef void ( *FuncStudioSetupBonesEngine )( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending, edict_t * pEdict, signed int iBone );
#endif

CFunc*	FuncStudioSetupBonesHook = NULL;
CFunc*	FuncStudioSetupBonesEngineHook = NULL;

FuncStudioSetupBones  FuncStudioSetupBonesOrig = NULL;
FuncStudioSetupBonesEngine  FuncStudioSetupBonesEngineOrig = NULL;

#ifdef _WIN32 
	void __cdecl FuncStudioSetupBones_EngineHook( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending, edict_t * pEdict, signed int iBone )
#else
	void FuncStudioSetupBones_EngineHook( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending, edict_t * pEdict, signed int iBone )
#endif
{
	if( FuncStudioSetupBonesEngineHook->Restore() )
	{
		FuncStudioSetupBonesEngineOrig(pModel,frame,sequence,angles,origin,pcontroller,pblending,iBone,pEdict);
		FuncStudioSetupBonesEngineHook->Patch();
	}
}

#ifdef _WIN32 
	void __cdecl FuncStudioSetupBones_GameHook( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending, edict_t * pEdict, signed int iBone )
#else
	void FuncStudioSetupBones_GameHook( struct model_s *pModel, float frame,int sequence,const vec3_t angles,const vec3_t origin,const byte *pcontroller,const byte *pblending, edict_t * pEdict, signed int iBone )
#endif
{
	signed int index = ENTINDEX(pEdict);

	if (index < 1 || index > gpGlobals->maxClients)
	{
		if( FuncStudioSetupBonesHook->Restore() )
		{
			FuncStudioSetupBones_EngineHook(pModel,frame,sequence,angles,origin,pcontroller,pblending,pEdict,iBone);
			FuncStudioSetupBonesHook->Patch();
		}
	}
	else
	{
		if( FuncStudioSetupBonesHook->Restore() )
		{
			FuncStudioSetupBones_GameHook(pModel,frame,sequence,angles,origin,pcontroller,pblending,pEdict,iBone);
			FuncStudioSetupBonesHook->Patch();
		}
	}
}

C_DLLEXPORT	int	Meta_Query(char	*ifvers, plugin_info_t **pPlugInfo,	mutil_funcs_t *pMetaUtilFuncs)
{
	gpMetaUtilFuncs = pMetaUtilFuncs;

	*pPlugInfo = &Plugin_info;

	return(TRUE);
}

static META_FUNCTIONS gMetaFunctionTable;
C_DLLEXPORT	int	Meta_Attach(PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs)
{
	gpMetaGlobals = pMGlobals;
	gpGamedllFuncs = pGamedllFuncs;


    #ifdef _WIN32 
        FuncStudioSetupBonesOrig = Hooker->MemorySearch< FuncStudioSetupBones >( "0x81,0xEC,*,*,*,*,0x53,0x55,0x8B,0xAC,0x24,0x68,0x02,0x00,0x00,0x56,0x57,0x55,0x33,0xFF,0xFF,0x15,*,*,*,*,0x8B,0x8C,0x24,0x7C,0x02,0x00,0x00,0x83,0xC4,0x04,0x85,0xC9,0xA3,*,*,*,*,0x7C,*,0x3B,0x88,0xA4,0x00,0x00,0x00,0x7C,*", ( void* )MDLL_Spawn, FALSE );
        FuncStudioSetupBonesEngineOrig = Hooker->MemorySearch< FuncStudioSetupBonesEngine >( "0x55,0x8B,0xEC,0x81,0xEC,*,*,*,*,0x8B,0x4D,0x10,0xA1,*,*,*,*,0x53,0x33,0xDB,0x56,0x57,0x85,0xC9,0x7C,-1,0x3B,0x88,0xA4,00,00,00,0x7C,*", ( void* )gpGlobals, FALSE );
    #else
        FuncStudioSetupBonesOrig = Hooker->MemorySearch< FuncStudioSetupBones>( "0x83,0xEC,0x0C,0x8B,0x44,0x24,0x10,0x8B,0x54,0x24,0x14,0xD9,0x40,0x04,0xD9,0x40,0x08,0xD9,0xC1,0xD8,0xC2,0xDE,0xCA,0xD9,0xE8,0xDC,0xE2,0xD9,0xC1,0xD8,0xC2,0xDE,0xCA,0xD9,0xCA,0xDE,0xE1,0xD9,0x1A,0xD9,0x00,0xD8,0xC0", ( void* )MDLL_Spawn, FALSE );
        FuncStudioSetupBonesEngineOrig = Hooker->MemorySearch< FuncStudioSetupBonesEngine>( "0x55,0x57,0x56,0x53,0x81,0xEC,*,*,*,*,0x8B,0x84,0x24,0xE8,0x02,0x00,0x00,0x8B,0x1D,*,*,*,*,0x8B,0xB4,0x24,0xFC,0x02,0x00,0x00,0x85,0xC0,0x8B,0x93,0xA4,0x00,0x00,0x00,0x78,*,0x39,0xD0,0x0F,0x8C,*,*,*,*", ( void* )gpGlobals, FALSE );
    #endif
	
	FuncStudioSetupBonesHook = Hooker->CreateHook( ( void* )FuncStudioSetupBonesOrig, ( void* )FuncStudioSetupBones_GameHook, TRUE );
	FuncStudioSetupBonesEngineHook = Hooker->CreateHook( ( void* )FuncStudioSetupBonesEngineOrig, ( void* )FuncStudioSetupBones_EngineHook, TRUE );

    if( !FuncStudioSetupBonesOrig )
        printf( "\n   %s v%s - by %s. [%s GameDLL] Signature/symbol could not be found.\n\n\n", Plugin_info.name, Plugin_info.version, Plugin_info.author, Plugin_info.name );
    else if( !FuncStudioSetupBonesEngineOrig )
        printf( "\n   %s v%s - by %s. [%s Engine] Signature/symbol could not be found.\n\n\n", Plugin_info.name, Plugin_info.version, Plugin_info.author, Plugin_info.name );
    else if( !FuncStudioSetupBonesHook )
        printf( "\n   %s v%s - by %s. [%s GameDLL] Hook creation failed.\n\n\n", Plugin_info.name, Plugin_info.version, Plugin_info.author, Plugin_info.name );
    else if( !FuncStudioSetupBonesEngineHook )
        printf( "\n   %s v%s - by %s. [%s Engine] Hook creation failed.\n\n\n", Plugin_info.name, Plugin_info.version, Plugin_info.author, Plugin_info.name );
    else 
        printf( "\n   %s v%s - by %s. Loaded with success\n\n\n", Plugin_info.name, Plugin_info.version, Plugin_info.author );

	memcpy(pFunctionTable, &gMetaFunctionTable, sizeof(META_FUNCTIONS));
	return(TRUE);
}

#ifdef __linux__
// linux prototype
C_DLLEXPORT void GiveFnptrsToDll(enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals)
{
#else
#ifdef _MSC_VER
// MSVC: Simulate __stdcall calling convention
C_DLLEXPORT __declspec(naked) void GiveFnptrsToDll(enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals)
{
	__asm			// Prolog
	{
		// Save ebp
		push		ebp
		// Set stack frame pointer
		mov			ebp, esp
		// Allocate space for local variables
		// The MSVC compiler gives us the needed size in __LOCAL_SIZE.
		sub			esp, __LOCAL_SIZE
		// Push registers
		push		ebx
		push		esi
		push		edi
	}
#else	// _MSC_VER
#ifdef __GNUC__
// GCC can also work with this
C_DLLEXPORT void __stdcall GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
#else	// __GNUC__
// compiler not known
#error There is no support (yet) for your compiler. Please use MSVC or GCC compilers or contact the AMX Mod X dev team.
#endif	// __GNUC__
#endif // _MSC_VER
#endif // __linux__

	// ** Function core <--
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;
	// --> ** Function core

#ifdef _MSC_VER
	// Epilog
	if (sizeof(int*) == 8)
	{	// 64 bit
		__asm
		{
			// Pop registers
			pop	edi
			pop	esi
			pop	ebx
			// Restore stack frame pointer
			mov	esp, ebp
			// Restore ebp
			pop	ebp
			// 2 * sizeof(int*) = 16 on 64 bit
			ret 16
		}
	}
	else
	{	// 32 bit
		__asm
		{
			// Pop registers
			pop	edi
			pop	esi
			pop	ebx
			// Restore stack frame pointer
			mov	esp, ebp
			// Restore ebp
			pop	ebp
			// 2 * sizeof(int*) = 8 on 32 bit
			ret 8
		}
	}
#endif // #ifdef _MSC_VER
}
